/* A Bison parser, made by GNU Bison 3.0.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2013 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 16 "gram.y" /* yacc.c:339  */

#include "./dbpmda.h"
#include "./lex.h"

extern int stmt_type;

static union {
    pmID	whole;
    __pmID_int	part;
} pmid;

static union {
    pmInDom		whole;
    __pmInDom_int	part;
} indom;


static int	sts;
static int	inst;
static char	*str;
static char	warnStr[80];

param_t	param;

/*
 * pmidp may contain a dynamic PMID ... if so, ask the PMDA to
 * translate name if possible
 */
static int
fix_dynamic_pmid(char *name, pmID *pmidp)
{
    int		sts;
    __pmPDU	*pb;
    extern int	outfd;
    extern int	infd;
    extern pmdaInterface	dispatch;

    if (pmid_domain(*pmidp) == DYNAMIC_PMID && pmid_item(*pmidp) == 0) {
	if (connmode == CONN_DSO) {
	    if (dispatch.comm.pmda_interface >= PMDA_INTERFACE_4) {
		sts = dispatch.version.four.pmid(name, pmidp, dispatch.version.four.ext);
		if (sts < 0) return sts;
	    }
	}
	else if (connmode == CONN_DAEMON) {
	    sts = __pmSendNameList(outfd, FROM_ANON, 1, &name, NULL);
	    if (sts < 0) return sts;
	    sts = __pmGetPDU(infd, ANY_SIZE, TIMEOUT_NEVER, &pb);
	    if (sts < 0) return sts;
	    if (sts == PDU_PMNS_IDS) {
		int	xsts;
		sts = __pmDecodeIDList(pb, 1, pmidp, &xsts);
		__pmUnpinPDUBuf(pb);
		if (sts < 0) return sts;
		return xsts;
	    }
	    else if (sts == PDU_ERROR) {
		__pmDecodeError(pb, &sts);
		__pmUnpinPDUBuf(pb);
		return sts;
	    }
	}
    }
    return 0;
}



#line 135 "gram.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.tab.h".  */
#ifndef YY_YY_GRAM_TAB_H_INCLUDED
# define YY_YY_GRAM_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    NUMBER2D = 258,
    NUMBER3D = 259,
    NUMBER = 260,
    NEGNUMBER = 261,
    FLAG = 262,
    NAME = 263,
    PATHNAME = 264,
    MACRO = 265,
    STRING = 266,
    COMMA = 267,
    EQUAL = 268,
    OPEN = 269,
    CLOSE = 270,
    DESC = 271,
    GETDESC = 272,
    FETCH = 273,
    INSTANCE = 274,
    PROFILE = 275,
    HELP = 276,
    WATCH = 277,
    DBG = 278,
    QUIT = 279,
    STATUS = 280,
    STORE = 281,
    INFO = 282,
    TIMER = 283,
    NAMESPACE = 284,
    WAIT = 285,
    PMNS_NAME = 286,
    PMNS_PMID = 287,
    PMNS_CHILDREN = 288,
    PMNS_TRAVERSE = 289,
    ATTR = 290,
    DSO = 291,
    PIPE = 292,
    SOCK = 293,
    UNIX = 294,
    INET = 295,
    IPV6 = 296,
    ADD = 297,
    DEL = 298,
    ALL = 299,
    NONE = 300,
    INDOM = 301,
    ON = 302,
    OFF = 303,
    PLUS = 304,
    EOL = 305
  };
#endif
/* Tokens.  */
#define NUMBER2D 258
#define NUMBER3D 259
#define NUMBER 260
#define NEGNUMBER 261
#define FLAG 262
#define NAME 263
#define PATHNAME 264
#define MACRO 265
#define STRING 266
#define COMMA 267
#define EQUAL 268
#define OPEN 269
#define CLOSE 270
#define DESC 271
#define GETDESC 272
#define FETCH 273
#define INSTANCE 274
#define PROFILE 275
#define HELP 276
#define WATCH 277
#define DBG 278
#define QUIT 279
#define STATUS 280
#define STORE 281
#define INFO 282
#define TIMER 283
#define NAMESPACE 284
#define WAIT 285
#define PMNS_NAME 286
#define PMNS_PMID 287
#define PMNS_CHILDREN 288
#define PMNS_TRAVERSE 289
#define ATTR 290
#define DSO 291
#define PIPE 292
#define SOCK 293
#define UNIX 294
#define INET 295
#define IPV6 296
#define ADD 297
#define DEL 298
#define ALL 299
#define NONE 300
#define INDOM 301
#define ON 302
#define OFF 303
#define PLUS 304
#define EOL 305

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE YYSTYPE;
union YYSTYPE
{
#line 85 "gram.y" /* yacc.c:355  */

	char		*y_str;
	int		y_num;
	twodot_num      y_2num;
	threedot_num    y_3num;
	

#line 283 "gram.tab.c" /* yacc.c:355  */
};
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_GRAM_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 298 "gram.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  107
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   209

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  51
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  13
/* YYNRULES -- Number of rules.  */
#define YYNRULES  105
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  191

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   133,   133,   137,   141,   145,   149,   153,   157,   161,
     164,   168,   172,   176,   179,   183,   188,   192,   197,   202,
     206,   212,   218,   224,   228,   238,   248,   259,   270,   274,
     278,   282,   286,   290,   294,   298,   302,   306,   310,   314,
     318,   323,   329,   333,   337,   341,   345,   349,   353,   357,
     361,   365,   369,   373,   377,   381,   385,   389,   393,   397,
     401,   405,   409,   413,   418,   419,   423,   427,   431,   435,
     438,   442,   445,   448,   452,   455,   458,   462,   465,   466,
     476,   477,   480,   481,   484,   493,   504,   505,   518,   530,
     544,   559,   574,   578,   582,   590,   599,   600,   601,   605,
     608,   609,   612,   613,   622,   623
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER2D", "NUMBER3D", "NUMBER",
  "NEGNUMBER", "FLAG", "NAME", "PATHNAME", "MACRO", "STRING", "COMMA",
  "EQUAL", "OPEN", "CLOSE", "DESC", "GETDESC", "FETCH", "INSTANCE",
  "PROFILE", "HELP", "WATCH", "DBG", "QUIT", "STATUS", "STORE", "INFO",
  "TIMER", "NAMESPACE", "WAIT", "PMNS_NAME", "PMNS_PMID", "PMNS_CHILDREN",
  "PMNS_TRAVERSE", "ATTR", "DSO", "PIPE", "SOCK", "UNIX", "INET", "IPV6",
  "ADD", "DEL", "ALL", "NONE", "INDOM", "ON", "OFF", "PLUS", "EOL",
  "$accept", "stmt", "fname", "optdomain", "attribute", "servport",
  "metric", "indom", "raw_pmid", "metriclist", "arglist", "inst", "debug", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305
};
# endif

#define YYPACT_NINF -44

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-44)))

#define YYTABLE_NINF -1

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      99,    40,   -43,    22,    59,    29,    -1,    39,   128,    49,
      42,    -9,     5,    35,    10,   117,    55,    12,     2,    15,
      21,    23,    11,   -44,    46,    55,    55,    61,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,    25,    34,    44,   -44,   -44,
     -44,    16,   -44,   -44,   -44,   -44,    43,   -44,    93,    47,
      60,    89,    90,    91,   116,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   129,   130,   131,   132,   133,
     -44,   -44,   -44,   -44,   134,    83,    83,   135,   136,   -44,
     137,   -44,   -44,   -44,    85,    77,   -44,   138,   139,   140,
     -44,   141,   142,   -44,   -44,   -44,   143,   144,   -44,   145,
     -44,   146,   -44,   -44,   -44,   -44,    24,   -44,   103,   -44,
      55,    48,    48,   -44,   -44,   -44,   -44,   100,   -44,   -44,
     147,   -44,   -44,   -44,   148,   194,   195,   151,   152,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   153,   154,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   155,   -44,   201,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   157,
     158,   -44,   -44,   -44,   -44,   -44,   -44,   159,   -44,   -44,
     -44
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,     2,     9,
      89,    90,    88,    91,    10,     0,     0,     0,    73,    12,
      96,     0,    94,    92,    93,    19,     0,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,    80,    81,    28,     0,   102,   103,     0,     0,    65,
       0,    64,    69,    14,     0,     0,    16,     0,     0,     0,
      70,     0,     0,    76,    95,    30,     0,     0,    32,     0,
      34,     0,    36,    84,    85,    39,     0,     1,     0,    99,
       0,     0,     0,     5,    11,    74,    75,     0,    13,    97,
       0,   101,   100,    20,     0,     0,     0,     0,     0,    51,
      43,    45,    47,    46,    49,    57,    63,    44,    58,    59,
      60,    48,    61,    50,    62,    53,    54,    52,    55,    56,
      29,   104,   105,    66,    67,    68,     0,     0,    17,    71,
      72,    38,    77,    31,    33,    35,    37,     0,    40,    83,
       4,     6,    86,    87,     7,     8,    98,    21,    22,     0,
       0,    24,    25,    15,    18,    41,    82,     0,    26,    27,
       3
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -44,   -44,   -15,   -44,   -44,   -14,    -5,    -4,   -44,   -44,
     -44,   -44,    -8
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    24,    74,   187,   106,   174,    35,    46,    96,    41,
     170,   124,    80
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_uint8 yytable[] =
{
      40,    91,    42,    48,    43,    44,    94,    29,    84,    87,
     108,   109,   113,    30,    31,    32,   103,    92,    33,    30,
      31,    32,   104,    97,    33,    30,    31,    32,   117,    99,
      33,   101,    30,    31,    32,   167,   119,    33,    30,    31,
      32,    81,    42,    33,    43,    44,   107,    75,   120,    45,
      76,   121,    95,   172,   122,    82,    85,    71,    72,   173,
      86,   105,    93,    71,    72,    98,   118,   151,   152,    71,
      72,   100,    34,   102,   168,   114,    25,    26,    27,    39,
      42,   157,    43,    44,   115,    83,    77,    78,    75,    47,
      28,    76,    79,   123,   116,   171,   156,   129,   175,    73,
     110,   111,   112,    30,    31,    32,    36,    37,    33,    38,
     130,   169,   176,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,   125,   126,   127,   128,   131,
     132,   133,    49,    50,    51,    52,    53,    54,    55,    23,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    88,    89,   134,    90,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,    70,   145,
     146,   147,   148,   149,   150,   153,   154,   155,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   188,   189,   190
};

static const yytype_uint8 yycheck[] =
{
       5,    16,     3,     7,     5,     6,     4,    50,    13,    14,
      25,    26,    27,     3,     4,     5,     5,     5,     8,     3,
       4,     5,    11,     8,     8,     3,     4,     5,    12,     8,
       8,     8,     3,     4,     5,    11,    41,     8,     3,     4,
       5,    50,     3,     8,     5,     6,     0,     5,     5,    50,
       8,     8,    50,     5,    11,    50,    46,     8,     9,    11,
      50,    50,    50,     8,     9,    50,    50,    75,    76,     8,
       9,    50,    50,    50,    50,    50,    36,    37,    38,    50,
       3,    85,     5,     6,    50,    50,    44,    45,     5,    50,
      50,     8,    50,    50,    50,   110,    11,    50,   112,    50,
      39,    40,    41,     3,     4,     5,    47,    48,     8,    50,
      50,     8,   117,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    42,    43,    44,    45,    50,
      50,    50,    14,    15,    16,    17,    18,    19,    20,    50,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    47,    48,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,     5,
       5,    50,    50,    50,    50,    50,     5,    50,    50,    50
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    50,    52,    36,    37,    38,    50,    50,
       3,     4,     5,     8,    50,    57,    47,    48,    50,    50,
      57,    60,     3,     5,     6,    50,    58,    50,    58,    14,
      15,    16,    17,    18,    19,    20,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      50,     8,     9,    50,    53,     5,     8,    44,    45,    50,
      63,    50,    50,    50,    57,    46,    50,    57,    47,    48,
      50,    53,     5,    50,     4,    50,    59,     8,    50,     8,
      50,     8,    50,     5,    11,    50,    55,     0,    53,    53,
      39,    40,    41,    53,    50,    50,    50,    12,    50,    57,
       5,     8,    11,    50,    62,    42,    43,    44,    45,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    63,    63,    50,    50,    50,    11,    58,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    11,    50,     8,
      61,    53,     5,    11,    56,    56,    57,    50,    50,     5,
       5,    50,    50,    50,    50,    50,     5,    54,    50,    50,
      50
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    51,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      53,    53,    54,    54,    55,    55,    56,    56,    57,    57,
      57,    57,    58,    58,    58,    59,    60,    60,    60,    61,
      62,    62,    63,    63,    63,    63
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     6,     4,     3,     4,     4,     4,     2,
       2,     3,     2,     3,     2,     4,     2,     3,     4,     2,
       3,     4,     4,     2,     4,     4,     5,     5,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     2,
       3,     4,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     3,     3,     3,     2,
       2,     3,     3,     2,     3,     3,     2,     3,     1,     0,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     0,
       1,     1,     1,     1,     2,     2
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 133 "gram.y" /* yacc.c:1646  */
    {
		param.number = OPEN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1512 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 137 "gram.y" /* yacc.c:1646  */
    {
		opendso((yyvsp[-3].y_str), (yyvsp[-2].y_str), (yyvsp[-1].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1521 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 141 "gram.y" /* yacc.c:1646  */
    {
		openpmda((yyvsp[-1].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1530 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 145 "gram.y" /* yacc.c:1646  */
    {
		open_unix_socket((yyvsp[0].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1539 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 149 "gram.y" /* yacc.c:1646  */
    {
		open_unix_socket((yyvsp[0].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1548 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 153 "gram.y" /* yacc.c:1646  */
    {
		open_inet_socket((yyvsp[0].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1557 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 157 "gram.y" /* yacc.c:1646  */
    {
		open_ipv6_socket((yyvsp[0].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
#line 1566 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 161 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = CLOSE; YYACCEPT; 
	    }
#line 1574 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 164 "gram.y" /* yacc.c:1646  */
    {
		param.number = DESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1583 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 168 "gram.y" /* yacc.c:1646  */
    {
		param.pmid = (yyvsp[-1].y_num);
		stmt_type = DESC; YYACCEPT;
	    }
#line 1592 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 172 "gram.y" /* yacc.c:1646  */
    {
		param.number = FETCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1601 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 176 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = FETCH; YYACCEPT; 
	    }
#line 1609 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 179 "gram.y" /* yacc.c:1646  */
    {
		param.number = STORE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1618 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 183 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		param.pmid = (pmID)(yyvsp[-2].y_num);
		stmt_type = STORE; YYACCEPT;
	    }
#line 1628 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 188 "gram.y" /* yacc.c:1646  */
    {
		param.number = INFO; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1637 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 192 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_TEXT_PMID;
		param.pmid = (pmID)(yyvsp[-1].y_num);
		stmt_type = INFO; YYACCEPT;
	    }
#line 1647 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 197 "gram.y" /* yacc.c:1646  */
    {
		param.number = PM_TEXT_INDOM;
		param.indom = indom.whole;
		stmt_type = INFO; YYACCEPT;
	    }
#line 1657 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 202 "gram.y" /* yacc.c:1646  */
    {
		param.number = INSTANCE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1666 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 206 "gram.y" /* yacc.c:1646  */
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
#line 1677 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 212 "gram.y" /* yacc.c:1646  */
    {
		param.indom = indom.whole;
		param.number = (yyvsp[-1].y_num);
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
#line 1688 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 218 "gram.y" /* yacc.c:1646  */
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = (yyvsp[-1].y_str);
		stmt_type = INSTANCE; YYACCEPT;
	    }
#line 1699 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 224 "gram.y" /* yacc.c:1646  */
    {
		param.number = PROFILE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1708 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 228 "gram.y" /* yacc.c:1646  */
    {
		sts = pmAddProfile((yyvsp[-2].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1723 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 238 "gram.y" /* yacc.c:1646  */
    {
		sts = pmDelProfile((yyvsp[-2].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1738 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 248 "gram.y" /* yacc.c:1646  */
    {
		inst = (yyvsp[-1].y_num);
		sts = pmAddProfile((yyvsp[-3].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1754 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 259 "gram.y" /* yacc.c:1646  */
    {
		inst = (yyvsp[-1].y_num);
		sts = pmDelProfile((yyvsp[-3].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
#line 1770 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 270 "gram.y" /* yacc.c:1646  */
    {
		param.number = WATCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1779 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 274 "gram.y" /* yacc.c:1646  */
    {
		watch((yyvsp[-1].y_str));
		stmt_type = WATCH; YYACCEPT;
	    }
#line 1788 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 278 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_NAME; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1797 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 282 "gram.y" /* yacc.c:1646  */
    {
		param.pmid = (yyvsp[-1].y_num);
		stmt_type = PMNS_NAME; YYACCEPT;
	    }
#line 1806 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 286 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_PMID; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1815 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 290 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = PMNS_PMID; YYACCEPT;
	    }
#line 1824 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 294 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1833 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 298 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = PMNS_CHILDREN; YYACCEPT;
	    }
#line 1842 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 302 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1851 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 306 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = PMNS_TRAVERSE; YYACCEPT;
	    }
#line 1860 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 310 "gram.y" /* yacc.c:1646  */
    {
		param.name = (yyvsp[-1].y_str);
		stmt_type = NAMESPACE; YYACCEPT;
	    }
#line 1869 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 314 "gram.y" /* yacc.c:1646  */
    {
		param.number = ATTR; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1878 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 318 "gram.y" /* yacc.c:1646  */
    {
		param.number = (yyvsp[-1].y_num);
		param.name = NULL;
		stmt_type = ATTR; YYACCEPT;
	    }
#line 1888 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 323 "gram.y" /* yacc.c:1646  */
    {
		param.number = (yyvsp[-2].y_num);
		param.name = (yyvsp[-1].y_str);
		stmt_type = ATTR; YYACCEPT;
	    }
#line 1898 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 329 "gram.y" /* yacc.c:1646  */
    { 
		param.number = -1; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT; 
	    }
#line 1907 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 333 "gram.y" /* yacc.c:1646  */
    {
		param.number = CLOSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1916 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 337 "gram.y" /* yacc.c:1646  */
    {
		param.number = DBG; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1925 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 341 "gram.y" /* yacc.c:1646  */
    {
		param.number = DESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1934 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 345 "gram.y" /* yacc.c:1646  */
    {
		param.number = FETCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1943 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 349 "gram.y" /* yacc.c:1646  */
    {
		param.number = GETDESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1952 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 353 "gram.y" /* yacc.c:1646  */
    {
		param.number = INFO; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
#line 1961 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 357 "gram.y" /* yacc.c:1646  */
    {
		param.number = INSTANCE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1970 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 361 "gram.y" /* yacc.c:1646  */
    {
		param.number = NAMESPACE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1979 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 365 "gram.y" /* yacc.c:1646  */
    {
		param.number = OPEN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1988 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 369 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 1997 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 373 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_NAME; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2006 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 377 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_PMID; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2015 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 381 "gram.y" /* yacc.c:1646  */
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2024 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 385 "gram.y" /* yacc.c:1646  */
    {
		param.number = ATTR; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2033 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 389 "gram.y" /* yacc.c:1646  */
    {
		param.number = PROFILE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2042 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 393 "gram.y" /* yacc.c:1646  */
    {
		param.number = QUIT; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2051 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 397 "gram.y" /* yacc.c:1646  */
    {
		param.number = STATUS; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2060 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 401 "gram.y" /* yacc.c:1646  */
    {
		param.number = STORE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2069 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 405 "gram.y" /* yacc.c:1646  */
    {
		param.number = TIMER; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2078 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 409 "gram.y" /* yacc.c:1646  */
    {
		param.number = WAIT; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2087 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 413 "gram.y" /* yacc.c:1646  */
    {
		param.number = WATCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2096 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 418 "gram.y" /* yacc.c:1646  */
    { stmt_type = QUIT; YYACCEPT; }
#line 2102 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 419 "gram.y" /* yacc.c:1646  */
    {
		param.number = DBG; param.pmid = HELP_USAGE; 
		stmt_type = HELP; YYACCEPT;
	    }
#line 2111 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 423 "gram.y" /* yacc.c:1646  */
    {
		param.number = -1;
		stmt_type = DBG; YYACCEPT;
	    }
#line 2120 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 427 "gram.y" /* yacc.c:1646  */
    {
		param.number = 0;
		stmt_type = DBG; YYACCEPT;
	    }
#line 2129 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 431 "gram.y" /* yacc.c:1646  */
    {
		param.number = (yyvsp[-1].y_num);
	        stmt_type = DBG; YYACCEPT;
	    }
#line 2138 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 435 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = STATUS; YYACCEPT; 
	    }
#line 2146 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 438 "gram.y" /* yacc.c:1646  */
    {
		param.number = TIMER; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2155 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 442 "gram.y" /* yacc.c:1646  */
    { 
		timer = 1; stmt_type = EOL; YYACCEPT; 
	    }
#line 2163 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 445 "gram.y" /* yacc.c:1646  */
    { 
		timer = 0; stmt_type = EOL; YYACCEPT; 
	    }
#line 2171 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 448 "gram.y" /* yacc.c:1646  */
    {
		param.number = GETDESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2180 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 452 "gram.y" /* yacc.c:1646  */
    { 
		get_desc = 1; stmt_type = EOL; YYACCEPT; 
	    }
#line 2188 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 455 "gram.y" /* yacc.c:1646  */
    { 
		get_desc = 0; stmt_type = EOL; YYACCEPT; 
	    }
#line 2196 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 458 "gram.y" /* yacc.c:1646  */
    {
		param.number = WAIT; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
#line 2205 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 462 "gram.y" /* yacc.c:1646  */
    { 
		stmt_type = EOL; sleep((yyvsp[-1].y_num)); YYACCEPT;
	    }
#line 2213 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 465 "gram.y" /* yacc.c:1646  */
    { stmt_type = EOL; YYACCEPT; }
#line 2219 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 466 "gram.y" /* yacc.c:1646  */
    {
		if (yywrap())
		    YYACCEPT;
		else {
		    yyerror("Unrecognized command");
		    YYERROR;
		}
	    }
#line 2232 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 476 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = strcons("./", (yyvsp[0].y_str)); }
#line 2238 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 477 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = (yyvsp[0].y_str); }
#line 2244 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 480 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = (yyvsp[0].y_num); }
#line 2250 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 481 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = 0; }
#line 2256 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 484 "gram.y" /* yacc.c:1646  */
    {
		sts = __pmAttrKeyStr_r((yyvsp[0].y_num), warnStr, sizeof(warnStr));
		if (sts <= 0) {
		    sprintf(warnStr, "Attribute (%d) is not recognised", (yyvsp[0].y_num));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = (yyvsp[0].y_num);
	    }
#line 2270 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 493 "gram.y" /* yacc.c:1646  */
    { 
		sts = __pmLookupAttrKey((yyvsp[0].y_str), strlen((yyvsp[0].y_str))+1);
		if (sts <= 0) {
		    sprintf(warnStr, "Attribute (%s) is not recognised", (yyvsp[0].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = sts;
	    }
#line 2284 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 504 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = (yyvsp[0].y_num); }
#line 2290 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 505 "gram.y" /* yacc.c:1646  */
    {
		struct servent *srv = getservbyname((yyvsp[0].y_str), NULL);
		if (srv == NULL) {
		    sprintf(warnStr, "Failed to map (%s) to a port number", (yyvsp[0].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		sprintf(warnStr, "Mapped %s to port number %d", (yyvsp[0].y_str), srv->s_port);
		yywarn(warnStr);
		(yyval.y_num) = srv->s_port;
	    }
#line 2306 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 518 "gram.y" /* yacc.c:1646  */
    { 
		pmid.whole = (yyvsp[0].y_num);
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole; 
	    }
#line 2323 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 530 "gram.y" /* yacc.c:1646  */
    {
		pmid.whole = 0;
		pmid.part.cluster = (yyvsp[0].y_2num).num1;
		pmid.part.item = (yyvsp[0].y_2num).num2;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2342 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 544 "gram.y" /* yacc.c:1646  */
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[0].y_3num).num1;
		pmid.part.cluster = (yyvsp[0].y_3num).num2;
		pmid.part.item = (yyvsp[0].y_3num).num3;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2362 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 559 "gram.y" /* yacc.c:1646  */
    {
		sts = pmLookupName(1, &(yyvsp[0].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		sts = fix_dynamic_pmid((yyvsp[0].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2380 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 574 "gram.y" /* yacc.c:1646  */
    { 
		indom.whole = (yyvsp[0].y_num);
	        (yyval.y_num) = (int)indom.whole;
	    }
#line 2389 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 578 "gram.y" /* yacc.c:1646  */
    { 
		indom.whole = (yyvsp[0].y_num);
		(yyval.y_num) = (int)indom.whole;
	    }
#line 2398 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 582 "gram.y" /* yacc.c:1646  */
    {
		indom.whole = 0;
		indom.part.domain = (yyvsp[0].y_2num).num1;
		indom.part.serial = (yyvsp[0].y_2num).num2;
		(yyval.y_num) = (int)indom.whole;
	    }
#line 2409 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 590 "gram.y" /* yacc.c:1646  */
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[0].y_3num).num1;
		pmid.part.cluster = (yyvsp[0].y_3num).num2;
		pmid.part.item = (yyvsp[0].y_3num).num3;
		(yyval.y_num) = (int)pmid.whole;
	    }
#line 2421 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 599 "gram.y" /* yacc.c:1646  */
    { addmetriclist((pmID)(yyvsp[0].y_num)); }
#line 2427 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 600 "gram.y" /* yacc.c:1646  */
    { addmetriclist((pmID)(yyvsp[0].y_num)); }
#line 2433 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 601 "gram.y" /* yacc.c:1646  */
    { addmetriclist((pmID)(yyvsp[0].y_num)); }
#line 2439 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 605 "gram.y" /* yacc.c:1646  */
    { doargs(); }
#line 2445 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 608 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = (yyvsp[0].y_str); }
#line 2451 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 609 "gram.y" /* yacc.c:1646  */
    { (yyval.y_str) = (yyvsp[0].y_str); }
#line 2457 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 612 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = (yyvsp[0].y_num); }
#line 2463 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 613 "gram.y" /* yacc.c:1646  */
    {
			sts = __pmParseDebug((yyvsp[0].y_str));
			if (sts < 0) {
			    sprintf(warnStr, "Bad debug flag (%s)", (yyvsp[0].y_str));
			    yywarn(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = sts;
		    }
#line 2477 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 622 "gram.y" /* yacc.c:1646  */
    { (yyval.y_num) = (yyvsp[-1].y_num) | (yyvsp[0].y_num); }
#line 2483 "gram.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 623 "gram.y" /* yacc.c:1646  */
    {
			sts = __pmParseDebug((yyvsp[-1].y_str));
			if (sts < 0) {
			    sprintf(warnStr, "Bad debug flag (%s)", (yyvsp[-1].y_str));
			    yywarn(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = sts | (yyvsp[0].y_num);
		    }
#line 2497 "gram.tab.c" /* yacc.c:1646  */
    break;


#line 2501 "gram.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 634 "gram.y" /* yacc.c:1906  */

